"use strict";

exports.__esModule = true;
exports.default = void 0;
var mpCompatData = _interopRequireWildcard(require("miniprogram-compat"));
var _coreJsCompat = _interopRequireDefault(require("core-js-compat"));
var _presetEnv = _interopRequireDefault(require("@babel/preset-env"));
var _semver = _interopRequireDefault(require("semver"));
var _helperPluginUtils = require("@babel/helper-plugin-utils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const babelPresetMiniprogram = (0, _helperPluginUtils.declare)((api, opts, dirname) => {
  api.assertVersion(7);
  let {
    wechatLibVersion,
    ...restOpts
  } = opts;
  wechatLibVersion = wechatLibVersion || "1.0.0";
  const browserslist = mpCompatData.getBrowsersList(wechatLibVersion);
  const polyfillInfo = mpCompatData.getPolyfillInfo(wechatLibVersion);
  if (!browserslist || !polyfillInfo) {
    throw new Error(`Wechat mini program version ${wechatLibVersion} is invalid.`);
  }
  if (_semver.default.major(restOpts.corejs) < 3) {
    throw new Error(`babel-preset-miniprogram only support core-js@3.`);
  }
  const polyfillsToIgnore = [];
  if (_semver.default.major(polyfillInfo.coreJsVersion) < 3) {
    // core js 2
    polyfillsToIgnore.push(...require("../data/core-js-2-modules.json").modules);
  } else {
    // core js 3
    polyfillsToIgnore.push(..._coreJsCompat.default.getModulesListForTargetVersion(polyfillInfo.coreJsVersion).filter(module => polyfillInfo.coreJsModules.indexOf(module) !== -1));
  }
  const result = (0, _presetEnv.default)(api, {
    corejs: 3,
    ...restOpts,
    ignoreBrowserslistConfig: true,
    exclude: (restOpts.exclude || []).concat(polyfillsToIgnore),
    targets: browserslist
  }, dirname);
  return result;
});
var _default = exports.default = babelPresetMiniprogram;